<?php

// For gmail compatibility, including CSS styles in head/body are stripped out therefore styles need to be inline. These variables contain rules which are added to the template inline.
$template_footer = "
	border-top:0;
	-webkit-border-radius:6px;
";

$credit = "
	border:0;
	font-family: Arial;
	font-size:12px;
	line-height:125%;
	text-align:center;
";
$header_color = get_option('bis_email_header_color');
$header_text_color = get_option('bis_email_header_text_color');
$body_color = get_option('bis_email_body_color');
$body_text_color = get_option('bis_email_body_text_color');

if (get_option('instock_subscription_akn_mail') == 'yes') { //sendmail if yes
    if (isset($_POST['variationid'])) {
        $var_id = $_POST['variationid'];
    } else {
        $var_id = 'no';
    }
    global $wpdb;
    global $woocommerce;
    $to = $_POST['notifyaddress']; // note the comma
    $currentuser_lang = empty($_POST['lang']) ? "en" : $_POST['lang'];
    if ($_POST['lang'] != 'not_active') {
        $subscribe_lang = $currentuser_lang;
        //subject translation
        $string = $wpdb->get_results($wpdb->prepare("SELECT id FROM {$wpdb->prefix}icl_strings WHERE context = %s AND name = %s AND language = %s ", 'admin_texts_plugin_backinstocknotifier', 'instock_subscription_email_subject', $subscribe_lang));

        if (!empty($string)) {
            $translated_string = $wpdb->get_results($wpdb->prepare("SELECT value FROM {$wpdb->prefix}icl_strings WHERE context = %s AND name = %s AND language = %s ", 'admin_texts_plugin_backinstocknotifier', 'instock_subscription_email_subject', $subscribe_lang));
            $translated_subject = $translated_string[0]->value;
        } else {
            $string = $wpdb->get_results($wpdb->prepare("SELECT id FROM {$wpdb->prefix}icl_strings WHERE context = %s AND name = %s ", 'admin_texts_plugin_backinstocknotifier', 'instock_subscription_email_subject'));
            $string_id = $string[0]->id;
            $translated_string = $wpdb->get_results("SELECT * FROM {$wpdb->prefix}icl_string_translations WHERE string_id = '$string_id' AND language= '$subscribe_lang'");
            // update_option('translated_string', $translated_string[0]->value);
            $translated_subject = $translated_string[0]->value;
        }
        if ($translated_subject == NULL) {
            $translated_subject = get_option('instock_subscription_email_subject');
        }

        //msassage translation
        $string = $wpdb->get_results($wpdb->prepare("SELECT id FROM {$wpdb->prefix}icl_strings WHERE context = %s AND name = %s AND language = %s ", 'admin_texts_plugin_backinstocknotifier', 'instock_subscription_email_messages', $subscribe_lang));
        if (!empty($string)) {
            $translated_string = $wpdb->get_results($wpdb->prepare("SELECT value FROM {$wpdb->prefix}icl_strings WHERE context = %s AND name = %s AND language = %s ", 'admin_texts_plugin_backinstocknotifier', 'instock_subscription_email_messages', $subscribe_lang));
            $translated_message = $translated_string[0]->value;
        } else {
            $string = $wpdb->get_results($wpdb->prepare("SELECT id FROM {$wpdb->prefix}icl_strings WHERE context = %s AND name = %s ", 'admin_texts_plugin_backinstocknotifier', 'instock_subscription_email_messages'));
            $string_id = $string[0]->id;
            $translated_string = $wpdb->get_results("SELECT * FROM {$wpdb->prefix}icl_string_translations WHERE string_id = '$string_id' AND language= '$subscribe_lang'");
            // update_option('translated_string', $translated_string[0]->value);
            $translated_message = $translated_string[0]->value;
        }

        if ($translated_message == NULL) {
            $translated_message = get_option('instock_subscription_email_messages');
        }
    } else {
        $translated_subject = get_option('instock_subscription_email_subject');
        $translated_message = get_option('instock_subscription_email_messages');
    }

    $unsubscribe_link = esc_url_raw(add_query_arg(array('bis_product_id' => $_POST['productid'], 'bis_variation_id' => $_POST['variationid'] != '' ? $_POST['variationid'] : 'no', 'bis_mailid' => $_POST['notifyaddress']), get_post_permalink($_POST['productid'])));
    $post_id = $_POST['productid'];
    $post = get_post($_POST['productid']);
    if ($post->post_type == 'product') {

        $subject = str_replace('[product_url]', get_permalink($post_id), str_replace('[product_title]', get_the_title($post_id), str_replace('[site_title]', get_option('blogname'), $translated_subject)));
        $message .= str_replace('[product_url]', "<a href=" . get_permalink($post_id) . ">" . get_permalink($post_id) . "</a>", str_replace('[product_title]', get_the_title($post_id), str_replace('[site_title]', get_option('blogname'), str_replace('[productinfo]', $tablecheckproduct, $translated_message))));


        add_filter('woocommerce_email_footer_text', array('BackInStockNotifier', 'footer_link'));

        ob_start();
        wc_get_template('emails/email-header.php', array('email_heading' => $subject));
        echo $message;
        wc_get_template('emails/email-footer.php');
        $woo_temp_msg = ob_get_clean();
        if ((float) $woocommerce->version <= (float) ('2.2.0')) {
            $mainname = get_option('woocommerce_email_from_name');
            $mainemail = get_option('woocommerce_email_from_address');
// To send HTML mail, the Content-type header must be set
            $headers = 'MIME-Version: 1.0' . "\r\n";
            $headers .= 'Content-type: text/html; charset=UTF-8' . "\r\n";
// Additional headers
            $headers .= 'From:' . $mainname . '  <' . $mainemail . '>' . "\r\n";
// Mail it


            if ('mail' == get_option('bis_mail_function')) {
                if (mail($to, $subject, $woo_temp_msg, $headers)) {
                    echo 'sent';
                }
            } elseif ('wp_mail' == get_option('bis_mail_function')) {
                if (wp_mail($to, $subject, $woo_temp_msg, $headers)) {
                    echo 'sent';
                }
            }
        } else {
            $mailer = WC()->mailer();
            $mailer->send($to, $subject, $woo_temp_msg, '', '');
            echo 'sent';
        }
    }
}
?>